﻿namespace Kreta.Framework.Collections.Generic
{
    public abstract class EntityCollectionDA<OwnerEntityType, CollectionEntityType> : IEntityCollectionDA<CollectionEntityType>
        where OwnerEntityType : Kreta.Framework.Entities.Entity
        where CollectionEntityType : Kreta.Framework.Entities.Entity
    {
        private OwnerEntityType m_Owner = null;

        protected internal EntityCollectionDA(OwnerEntityType owner)
        {
            m_Owner = owner;
        }

        private EntityCollectionDA()
        {
        }

        protected OwnerEntityType Owner
        {
            get
            {
                return m_Owner;
            }
        }

        public abstract void LoadCollection(IAssociatedEntityCollection<CollectionEntityType> collection);

        public abstract void AddItem(CollectionEntityType entity);

        public abstract void DeleteItem(CollectionEntityType entity);
    }
}
